/**
 * Fuse.js v5.2.0-alpha.2 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2020 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */
var e,t;e=this,t=function(){"use strict";function e(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function t(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function r(e,r,n){return r&&t(e.prototype,r),n&&t(e,n),e}function n(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function i(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function o(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?i(Object(r),!0).forEach((function(t){n(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):i(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var s=function(e){return Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e)},a=function(e){return"string"==typeof e},c=function(e){return"number"==typeof e},h=function(e){return null!=e};function l(e,t){var r=[],n=!1;return function e(t,i){if(i){var o=i.indexOf("."),l=i,u=null;-1!==o&&(l=i.slice(0,o),u=i.slice(o+1));var f=t[l];if(h(f))if(u||!a(f)&&!c(f))if(s(f)){n=!0;for(var v=0,d=f.length;v<d;v+=1)e(f[v],u)}else u&&e(f,u);else r.push(function(e){return null==e?"":function(e){if("string"==typeof e)return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}(e)}(f))}else r.push(t)}(e,t),n?r:r[0]}var u=o({},{isCaseSensitive:!1,includeScore:!1,keys:[],shouldSort:!0,sortFn:function(e,t){return e.score-t.score}},{},{includeMatches:!1,findAllMatches:!1,minMatchCharLength:1},{},{location:0,threshold:.6,distance:100},{},{useExtendedSearch:!1,getFn:l});function f(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=t.errors,n=void 0===r?0:r,i=t.currentLocation,o=void 0===i?0:i,s=t.expectedLocation,a=void 0===s?0:s,c=t.distance,h=void 0===c?u.distance:c,l=n/e.length,f=Math.abs(a-o);return h?l+f/h:f?1:l}function v(){for(var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:u.minMatchCharLength,r=[],n=-1,i=-1,o=0,s=e.length;o<s;o+=1){var a=e[o];a&&-1===n?n=o:a||-1===n||((i=o-1)-n+1>=t&&r.push([n,i]),n=-1)}return e[o-1]&&o-n>=t&&r.push([n,o-1]),r}function d(e){for(var t={},r=e.length,n=0;n<r;n+=1)t[e.charAt(n)]=0;for(var i=0;i<r;i+=1)t[e.charAt(i)]|=1<<r-i-1;return t}var p=function(){function t(r){var n,i,o,s,a,c,h,l,f=arguments.length>1&&void 0!==arguments[1]?arguments[1]:(i=(n={}).location,location=void 0===i?u.location:i,o=n.threshold,threshold=void 0===o?u.threshold:o,s=n.distance,distance=void 0===s?u.distance:s,a=n.includeMatches,includeMatches=void 0===a?u.includeMatches:a,c=n.findAllMatches,findAllMatches=void 0===c?u.findAllMatches:c,h=n.minMatchCharLength,minMatchCharLength=void 0===h?u.minMatchCharLength:h,l=n.isCaseSensitive,isCaseSensitive=void 0===l?u.isCaseSensitive:l,n);if(e(this,t),this.options=f,r.length>32)throw new Error("Pattern length exceeds max of ".concat(32,"."));this.pattern=this.options.isCaseSensitive?r:r.toLowerCase(),this.patternAlphabet=d(this.pattern)}return r(t,[{key:"searchIn",value:function(e){var t=e.$;return this.searchInString(t)}},{key:"searchInString",value:function(e){var t=this.options,r=t.isCaseSensitive,n=t.includeMatches;if(r||(e=e.toLowerCase()),this.pattern===e){var i={isMatch:!0,score:0};return n&&(i.matchedIndices=[[0,e.length-1]]),i}var o=this.options,s=o.location,a=o.distance,c=o.threshold,h=o.findAllMatches,l=o.minMatchCharLength;return function(e,t,r){for(var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},i=n.location,o=void 0===i?u.location:i,s=n.distance,a=void 0===s?u.distance:s,c=n.threshold,h=void 0===c?u.threshold:c,l=n.findAllMatches,d=void 0===l?u.findAllMatches:l,p=n.minMatchCharLength,g=void 0===p?u.minMatchCharLength:p,y=n.includeMatches,m=void 0===y?u.includeMatches:y,k=t.length,M=e.length,x=Math.max(0,Math.min(o,M)),b=h,_=e.indexOf(t,x),w=[],O=0;O<M;O+=1)w[O]=0;if(-1!==_){var S=f(t,{errors:0,currentLocation:_,expectedLocation:x,distance:a});if(b=Math.min(S,b),-1!==(_=e.lastIndexOf(t,x+k))){var L=f(t,{errors:0,currentLocation:_,expectedLocation:x,distance:a});b=Math.min(L,b)}}_=-1;for(var I=[],A=1,C=k+M,j=1<<(k<=31?k-1:30),P=0;P<k;P+=1){for(var $=0,E=C;$<E;){var N=f(t,{errors:P,currentLocation:x+E,expectedLocation:x,distance:a});N<=b?$=E:C=E,E=Math.floor((C-$)/2+$)}C=E;var F=Math.max(1,x-E+1),D=d?M:Math.min(x+E,M)+k,J=Array(D+2);J[D+1]=(1<<P)-1;for(var K=D;K>=F;K-=1){var U=K-1,T=r[e.charAt(U)];if(T&&(w[U]=1),J[K]=(J[K+1]<<1|1)&T,0!==P&&(J[K]|=(I[K+1]|I[K])<<1|1|I[K+1]),J[K]&j&&(A=f(t,{errors:P,currentLocation:U,expectedLocation:x,distance:a}))<=b){if(b=A,(_=U)<=x)break;F=Math.max(1,2*x-_)}}var q=f(t,{errors:P+1,currentLocation:x,expectedLocation:x,distance:a});if(q>b)break;I=J}var z={isMatch:_>=0,score:A||.001};return m&&(z.matchedIndices=v(w,g)),z}(e,this.pattern,this.patternAlphabet,{location:s,distance:a,threshold:c,findAllMatches:h,minMatchCharLength:l,includeMatches:n})}}]),t}();function g(e,t){var r=t.n,n=void 0===r?3:r,i=t.pad,o=void 0===i||i,s=t.sort,a=void 0!==s&&s,c=[];if(null==e)return c;e=e.toLowerCase(),o&&(e=" ".concat(e," "));var h=e.length-n+1;if(h<1)return c;for(;h--;)c[h]=e.substr(h,n);return a&&c.sort((function(e,t){return e==t?0:e<t?-1:1})),c}function y(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=r.getFn,i=void 0===n?l:n,o=r.ngrams,c=void 0!==o&&o,u=[];if(a(t[0]))for(var f=0,v=t.length;f<v;f+=1){var d=t[f];if(h(d)){var p={$:d,idx:f};c&&(p.ng=g(d,{sort:!0})),u.push(p)}}else for(var y=e.length,m=0,k=t.length;m<k;m+=1){for(var M=t[m],x={idx:m,$:{}},b=0;b<y;b+=1){var _=e[b],w=i(M,_);if(h(w))if(s(w)){for(var O=[],S=[{arrayIndex:-1,value:w}];S.length;){var L=S.pop(),I=L.arrayIndex,A=L.value;if(h(A))if(a(A)){var C={$:A,idx:I};c&&(C.ng=g(A,{sort:!0})),O.push(C)}else if(s(A))for(var j=0,P=A.length;j<P;j+=1)S.push({arrayIndex:j,value:A[j]})}x.$[_]=O}else{var $={$:w};c&&($.ng=g(w,{sort:!0})),x.$[_]=$}}u.push(x)}return u}var m=function(){function t(r){if(e(this,t),this._keys={},this._keyNames=[],this._length=r.length,r.length&&a(r[0]))for(var n=0;n<this._length;n+=1){var i=r[n];this._keys[i]={weight:1},this._keyNames.push(i)}else{for(var o=0,s=0;s<this._length;s+=1){var c=r[s];if(!Object.prototype.hasOwnProperty.call(c,"name"))throw new Error('Missing "name" property in key object');var h=c.name;if(this._keyNames.push(h),!Object.prototype.hasOwnProperty.call(c,"weight"))throw new Error('Missing "weight" property in key object');var l=c.weight;if(l<=0||l>=1)throw new Error('"weight" property in key must be in the range of (0, 1)');this._keys[h]={weight:l},o+=l}for(var u=0;u<this._length;u+=1){var f=this._keyNames[u],v=this._keys[f].weight;this._keys[f].weight=v/o}}}return r(t,[{key:"get",value:function(e,t){return this._keys[e]?this._keys[e][t]:-1}},{key:"keys",value:function(){return this._keyNames}},{key:"count",value:function(){return this._length}},{key:"toJSON",value:function(){return JSON.stringify(this._keys)}}]),t}();function k(e,t){var r=e.matches;if(t.matches=[],h(r))for(var n=0,i=r.length;n<i;n+=1){var o=r[n];if(h(o.indices)&&0!==o.indices.length){var s={indices:o.indices,value:o.value};o.key&&(s.key=o.key),o.idx>-1&&(s.refIndex=o.idx),t.matches.push(s)}}}function M(e,t){t.score=e.score}var x=[],b=function(){function t(r){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;e(this,t),this.options=o({},u,{},n),this._processKeys(this.options.keys),this.setCollection(r,i)}return r(t,[{key:"setCollection",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this.list=e,this.listIsStringArray=a(e[0]),t?this.setIndex(t):this.setIndex(this._createIndex())}},{key:"setIndex",value:function(e){this._indexedList=e}},{key:"_processKeys",value:function(e){this._keyStore=new m(e)}},{key:"_createIndex",value:function(){return y(this._keyStore.keys(),this.list,{getFn:this.options.getFn})}},{key:"search",value:function(e){for(var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{limit:!1},r=this.options.shouldSort,n=null,i=0,o=x.length;i<o;i+=1){var s=x[i];if(s.condition(e,this.options)){n=new s(e,this.options);break}}n||(n=new p(e,this.options));var a=this._searchUsing(n);return this._computeScore(a),r&&this._sort(a),t.limit&&c(t.limit)&&(a=a.slice(0,t.limit)),this._format(a)}},{key:"_searchUsing",value:function(e){var t=this._indexedList,r=[],n=this.options.includeMatches;if(this.listIsStringArray)for(var i=0,o=t.length;i<o;i+=1){var a=t[i],c=a.$,l=a.idx;if(h(c)){var u=e.searchIn(a),f=u.isMatch,v=u.score;if(f){var d={score:v,value:c};n&&(d.indices=u.matchedIndices),r.push({item:c,idx:l,matches:[d]})}}}else for(var p=this._keyStore.keys(),g=this._keyStore.count(),y=0,m=t.length;y<m;y+=1){var k=t[y],M=k.$,x=k.idx;if(h(M)){for(var b=[],_=0;_<g;_+=1){var w=p[_],O=M[w];if(h(O))if(s(O))for(var S=0,L=O.length;S<L;S+=1){var I=O[S],A=I.$,C=I.idx;if(h(A)){var j=e.searchIn(I),P=j.isMatch,$=j.score;if(P){var E={score:$,key:w,value:A,idx:C};n&&(E.indices=j.matchedIndices),b.push(E)}}}else{var N=O.$,F=e.searchIn(O),D=F.isMatch,J=F.score;if(!D)continue;var K={score:J,key:w,value:N};n&&(K.indices=F.matchedIndices),b.push(K)}}b.length&&r.push({idx:x,item:M,matches:b})}}return r}},{key:"_computeScore",value:function(e){for(var t=0,r=e.length;t<r;t+=1){for(var n=e[t],i=n.matches,o=i.length,s=1,a=0;a<o;a+=1){var c=i[a],h=c.key,l=this._keyStore.get(h,"weight"),u=l>-1?l:1,f=0===c.score&&l>-1?Number.EPSILON:c.score;s*=Math.pow(f,u)}n.score=s}}},{key:"_sort",value:function(e){e.sort(this.options.sortFn)}},{key:"_format",value:function(e){var t=[],r=this.options,n=r.includeMatches,i=r.includeScore,o=[];n&&o.push(k),i&&o.push(M);for(var s=0,a=e.length;s<a;s+=1){var c=e[s],h=c.idx,l={item:this.list[h],refIndex:h};if(o.length)for(var u=0,f=o.length;u<f;u+=1)o[u](c,l);t.push(l)}return t}}]),t}();return b.version="5.2.0-alpha.2",b.createIndex=y,b.config=u,b},"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Fuse=t();